#!/usr/bin/perl

$MAX_TZS = 50;

@a = @ARGV;

$max = 0;

$tz_idx = 0;
$O1 = mc_begin("TzData$tz_idx");

open O2, ">settings.xml";
$pre2 = "";

open I, "<$a[0]";
while (<I>) {
	chop;
	$data = $_;

	$name = $data;
	$data =~ s/	.*//;
	$name =~ s/.*	//;
	$sign = substr($data, 0, 1);
	$d = $data;
	$d =~ s/.//;
	@token = split(';|:', $d);
	$hr = 0 + $token[0];
	$min = 0 + $token[1];
	print $O1 "$pre1    [ $sign($hr*60+$min), \"$token[2]\"";
	$pre1 = ",\n";
	if ($token[3] ne "") {
		print $O1 ", \"$token[3]\", $token[4], \"$name\" ]";
	} else {
		print $O1 ", \"\", -1, \"$name\" ]";
	}

	$tz_entry += 1;
	if ($tz_entry >= $MAX_TZS) {
		mc_end($O1);
		$tz_idx += 1;
		$O1 = mc_begin("TzData$tz_idx");
	}

	print O2 "$pre2            <listEntry value=\"$max\">$name</listEntry>";
	$pre2 = "\n";
	$max += 1;
}
close I;

print O2 "\n";
close O2;

mc_end($O1);

sub mc_begin
{
	local ($name) = @_;

	open O, ">$name.mc";
	print O "class $name\n";
	print O "{\n";
	print O "var tz_info = [";
	$tz_entry = 0;
	$pre1 = "\n";
	return O;
}

sub mc_end
{
	local ($O1) = @_;

	print $O1 "\n";
	print $O1 <<END;
];

public function initialize()
{
}

public function get(idx)
{

    return tz_info[idx];
}

}
END
	close $O1;
}
